%define real_name nc

Name:           netcat-traditional
Version:        1.10
Release:        %mkrel 45
Summary:        Reads and writes data across network connections using TCP or UDP
License:        Public Domain
Group:          Networking/Other
URL:            https://nc110.sourceforge.net/
Source0:        https://sourceforge.net/projects/nc110/files/unix%20netcat%201.10%20by%20_Hobbit_/%5BUnnamed%20release%5D/nc110.tgz
Source1:        %{real_name}.1
Patch0:         unstripped.patch
Patch1:         glibc-resolv-h.patch
Patch2:         arm-timer.patch
Patch3:         posix-setjmp.patch
Patch4:         no-sleep-punt.patch
Patch5:         single-verbose.patch
Patch6:         use-getservbyport.patch
Patch7:         read-overflow.patch
Patch8:         inet-aton.patch
Patch9:         udp-broadcast.patch
Patch10:        quit.patch
Patch11:        dash-port.patch
Patch12:        sh-c.patch
Patch13:        tos.patch
Patch14:        rservice-buf.patch
Patch15:        so-keepalive.patch
Patch16:        nodup-stderr.patch
Patch17:        help-exit-failure.patch
Patch18:        darwin-ipproto.patch
Patch19:        select-nfds.patch
Patch20:        proxy-doc.patch
Patch30:        nc-1.10-format_not_a_string_literal_and_no_format_arguments.diff
Patch31:        nc-1.10-LDFLAGS.patch
Patch32:        missing-prototypes.patch
Patch33:        implicit-int.patch
Provides:       netcat = 1.0

%description
The nc package contains Netcat (the program is now netcat), a simple utility
for reading and writing data across network connections, using the TCP or UDP
protocols. Netcat is intended to be a reliable back-end tool which can be used
directly or easily driven by other programs and scripts. Netcat is also a
feature-rich network debugging and exploration tool, since it can create many
different connections and has many built-in capabilities.

You may want to install the netcat package if you are administering a network
and you'd like to use its debugging and network exploration capabilities.

netcat has been compiled with -DGAPING_SECURITY_HOLE turned on. I do not
believe this is as much of a security hole as the author makes it out to be,
*if* you know what you're doing (but then, if you didn't, you'd still be using
telnet ;-)). Since the spawned program will run as whatever user started
netcat, don't use -e as root. You have been warned, so if some cracker breaks
into your system due to your own stupidity, don't blame me.

A symlink to the netcat binary called 'netcat' has been installed. However, the
canonical name is still 'nc'. If you use netcat on other systems, it will
probably only be installed as 'nc', so keep this in mind when writing scripts.

%prep
%setup -q -c

%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1
%patch -P 3 -p1
%patch -P 4 -p1
%patch -P 5 -p1
%patch -P 6 -p1
%patch -P 7 -p1
%patch -P 8 -p1
%patch -P 9 -p1
%patch -P 10 -p1
%patch -P 11 -p1
%patch -P 12 -p1
%patch -P 13 -p1
%patch -P 14 -p1
%patch -P 15 -p1
%patch -P 16 -p1
%patch -P 17 -p1
%patch -P 18 -p1
%patch -P 19 -p1
%patch -P 20 -p1

%patch -P 30 -p0
%patch -P 31 -p0

%patch -P 32 -p1
%patch -P 33 -p1

%build
# Make linux ids supported, but it makes a static binary.
make CFLAGS="%{optflags}" LDFLAGS="%{ldflags}" \
          DFLAGS='-DLINUX -DTELNET -DGAPING_SECURITY_HOLE' generic

%install
install -Dpm 755 nc %{buildroot}%{_bindir}/nc-traditional
install -Dpm 644 %{SOURCE1} %{buildroot}%{_mandir}/man1/nc-traditional.1

# for alternatives
touch %{buildroot}%{_bindir}/nc
touch %{buildroot}%{_bindir}/netcat
touch %{buildroot}%{_mandir}/man1/nc.1%{?_extension}
touch %{buildroot}%{_mandir}/man1/netcat.1%{?_extension}

%triggerprein -- netcat-traditional < 1.10-45
if [ -f %{_bindir}/nc ]; then
  rm -rf %{_bindir}/nc
fi
if [ -f %{_mandir}/man1/nc.1%{?_extension} ]; then
  rm -rf %{_mandir}/man1/nc.1%{?_extension}
fi

%post
%{_sbindir}/alternatives \
  --install %{_bindir}/nc nc %{_bindir}/nc-traditional 2 \
  --slave %{_bindir}/netcat netcat %{_bindir}/nc-traditional \
  --slave %{_mandir}/man1/nc.1.xz nc-man %{_mandir}/man1/nc-traditional.1.xz \
  --slave %{_mandir}/man1/netcat.1.xz netcat-man %{_mandir}/man1/nc-traditional.1.xz

%preun
if [ $1 -eq 0 ]; then
  %{_sbindir}/alternatives --remove nc %{_bindir}/nc-traditional
fi

%files
%doc README Changelog scripts
%ghost %{_bindir}/nc
%ghost %{_bindir}/netcat
%{_bindir}/nc-traditional
%ghost %{_mandir}/man1/nc.1*
%ghost %{_mandir}/man1/netcat.1*
%{_mandir}/man1/nc-traditional.1*


%changelog
* Sat Nov 09 2024 wally <wally> 1.10-45.mga10
+ Revision: 2113384
- use alternatives system

* Wed Nov 06 2024 ns80 <ns80> 1.10-44.mga10
+ Revision: 2112761
- port patches from Debian to try to fix building with GCC 14

* Tue Mar 15 2022 tv <tv> 1.10-43.mga9
+ Revision: 1793211
- Fix bad ln macro replacement in r1583331
+ umeabot <umeabot>
- Mageia 9 Mass Rebuild
+ pterjan <pterjan>
- Remove usage of obsolete macros (https://github.com/rpm-software-management/rpm/issues/1211)
+ danf <danf>
- Switch URLs from http: to https:

* Thu Feb 13 2020 umeabot <umeabot> 1.10-42.mga8
+ Revision: 1515348
- Mageia 8 Mass Rebuild

* Sun Sep 23 2018 umeabot <umeabot> 1.10-41.mga7
+ Revision: 1299701
- Mageia 7 Mass Rebuild

* Mon Feb 01 2016 umeabot <umeabot> 1.10-40.mga6
+ Revision: 930026
- Mageia 6 Mass Rebuild

* Wed Oct 15 2014 umeabot <umeabot> 1.10-39.mga5
+ Revision: 744019
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 1.10-38.mga5
+ Revision: 682844
- Mageia 5 Mass Rebuild

* Fri Oct 18 2013 umeabot <umeabot> 1.10-37.mga4
+ Revision: 508298
- Mageia 4 Mass Rebuild
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Feb 23 2011 ennael <ennael> 1.10-35.mga1
+ Revision: 58148
- imported package netcat-traditional


* Sat Jul 17 2010 Guillaume Rousse <guillomovitch@mandriva.org> 1.10-35mdv2011.0
+ Revision: 554525
- sync with debian patches set
- fix URL (bug #59930)

* Mon Mar 15 2010 Oden Eriksson <oeriksson@mandriva.com> 1.10-34mdv2010.1
+ Revision: 520189
- rebuilt for 2010.1

* Thu Sep 03 2009 Christophe Fergeau <cfergeau@mandriva.com> 1.10-33mdv2010.0
+ Revision: 426251
- rebuild

* Wed Jan 21 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.10-32mdv2009.1
+ Revision: 332125
- provides a versionned netcat virtual package

* Tue Jan 20 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.10-31mdv2009.1
+ Revision: 331766
- add a conflict with old netcat package

* Mon Jan 19 2009 Guillaume Rousse <guillomovitch@mandriva.org> 1.10-30mdv2009.1
+ Revision: 331437
- package renaming
- ship netcat binary
- provides netcat virtual package
- package renaming

* Mon Dec 22 2008 Oden Eriksson <oeriksson@mandriva.com> 1.10-29mdv2009.1
+ Revision: 317477
- fix build with -Werror=format-security (P11)
- use %%ldflags (P12)

* Tue Jun 17 2008 Thierry Vignaud <tv@mandriva.org> 1.10-28mdv2009.0
+ Revision: 223334
- rebuild

* Tue Jan 15 2008 Thierry Vignaud <tv@mandriva.org> 1.10-27mdv2008.1
+ Revision: 153277
- rebuild
- kill re-definition of %%buildroot on Pixel's request

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

* Thu Apr 19 2007 David Walluck <walluck@mandriva.org> 1.10-26mdv2008.0
+ Revision: 15163
- bump release
- license is not GPL (see README)
- don't use %%{make} (jobserver unavailable)

* Thu Apr 19 2007 David Walluck <walluck@mandriva.org> 1.10-24mdv2008.0
+ Revision: 15150
- use only nc, not netcat

* Thu Apr 19 2007 David Walluck <walluck@mandriva.org> 1.10-23mdv2008.0
+ Revision: 15149
- better package compatibility with GNU netcat

